"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.extractModuleDependenciesFromFile = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var babylon = _interopRequireWildcard(require("@babel/parser"));

var _traverse = _interopRequireDefault(require("@babel/traverse"));

var _globAll = _interopRequireDefault(require("glob-all"));

var _traverser = _interopRequireDefault(require("./traverser"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ENCODING = 'utf8';
var BABEL_PARSING_OPTS = {
  sourceType: 'module',
  plugins: ['jsx', 'flow', 'doExpressions', 'objectRestSpread', 'decorators-legacy', 'classProperties', 'exportExtensions', 'asyncGenerators', 'functionBind', 'functionSent', 'dynamicImport']
};

var noop = function noop() {};

var jsExtLength = '.js'.length;
var mustacheExt = '.mustache';
var backslashLength = '/'.length;

var extractModuleDependenciesFromCode = function extractModuleDependenciesFromCode(code) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var cb = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : noop;

  try {
    var ast = babylon.parse(code.toString(ENCODING), BABEL_PARSING_OPTS);
    var traverser = (0, _traverser["default"])(cb, opts);
    (0, _traverse["default"])(ast, traverser);
  } catch (ignore) {}
};

var extractModuleDependenciesFromFile = function extractModuleDependenciesFromFile(file) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var cb = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : noop;
  extractModuleDependenciesFromCode(_fs["default"].readFileSync(file, ENCODING), _objectSpread(_objectSpread({}, opts), {}, {
    filename: file
  }), cb);
};

exports.extractModuleDependenciesFromFile = extractModuleDependenciesFromFile;

var extractModuleTreeDependenciesFromFile = function extractModuleTreeDependenciesFromFile(file) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var cachedFiles = {};
  var dependencyList = [];

  function _extractModuleTreeDependenciesFromFile(file, opts) {
    var moduleDependecies = [];
    extractModuleDependenciesFromFile(file, opts, function (_moduleDependecies) {
      dependencyList = dependencyList.concat(_moduleDependecies);
      moduleDependecies = _moduleDependecies;
    });
    moduleDependecies.forEach(function (file) {
      if (!cachedFiles[file]) {
        _extractModuleTreeDependenciesFromFile(file, opts);

        cachedFiles[file] = true;
      }
    });
  }

  _extractModuleTreeDependenciesFromFile(file, opts);

  return _toConsumableArray(new Set(dependencyList));
};

var _default = function _default(globArr) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var saveFilePath = _path["default"].resolve(opts.saveFilePath);

  var previousContent;

  var staticValues = _globAll["default"].sync(globArr).reduce(function (dependencies, file) {
    var staticValues = extractModuleTreeDependenciesFromFile(file, opts);
    dependencies = dependencies.concat([file], staticValues);
    return dependencies;
  }, []);

  var modulesPath = _path["default"].resolve(__dirname, opts.modulesPath);

  staticValues = _toConsumableArray(new Set(staticValues.map(function (item) {
    return item.slice(modulesPath.length + backslashLength);
  })));

  if (_fs["default"].existsSync("".concat(saveFilePath, "/").concat(opts.saveFileName, ".").concat(opts.saveFileExt))) {
    previousContent = _fs["default"].readFileSync("".concat(saveFilePath, "/").concat(opts.saveFileName, ".").concat(opts.saveFileExt), ENCODING).toString();
  }

  var content = opts.template ? opts.template(staticValues) : JSON.stringify(staticValues);

  if (content !== previousContent) {
    _fs["default"].writeFileSync("".concat(saveFilePath, "/").concat(opts.saveFileName, ".").concat(opts.saveFileExt), content);
  }
};

exports["default"] = _default;